=== debian/changelog ===
deepin-devicemanager (6.0.52) unstable; urgency=medium

  * chore: Update debian packaging and service configuration
  * refactor: Service safety rectification

 -- wangrong <wangrong@uniontech.com>  Thu, 13 Nov 2025 20:06:28 +0800
